'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isRemovablePath = require('./isRemovablePath');

var _isRemovablePath2 = _interopRequireDefault(_isRemovablePath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var findReferenceRemovalPath = function findReferenceRemovalPath(referencePath) {
  var parent = referencePath.findParent(_isRemovablePath2.default);

  if (parent) return parent;
  if ((0, _isRemovablePath2.default)(referencePath)) return referencePath;

  throw new Error(['Cannot find the path for removal, please open issue with code example and the stack trace on Github:', 'https://github.com/ember-cli/babel-plugin-filter-imports'].join(' '));
};

exports.default = findReferenceRemovalPath;