'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _findReferenceRemovalPath = require('./findReferenceRemovalPath');

var _findReferenceRemovalPath2 = _interopRequireDefault(_findReferenceRemovalPath);

var _removeExportSpecifier = require('./removeExportSpecifier');

var _removeExportSpecifier2 = _interopRequireDefault(_removeExportSpecifier);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var removeReferences = function removeReferences(path, specifier) {
  if (!path.scope.getBinding(specifier)) return;

  var _path$scope$getBindin = path.scope.getBinding(specifier),
      referencePaths = _path$scope$getBindin.referencePaths;

  _lodash2.default.forEach(referencePaths, function (referencePath) {
    var removalPath = (0, _findReferenceRemovalPath2.default)(referencePath);

    if (removalPath.removed) return;
    if (t.isArrowFunctionExpression(removalPath)) {
      removalPath.get('body').remove();
      return;
    }
    if (t.isExportSpecifier(removalPath)) {
      (0, _removeExportSpecifier2.default)(removalPath);
      return;
    }
    if (t.isVariableDeclarator(removalPath)) removeReferences(removalPath, _lodash2.default.get(removalPath, 'node.id.name'));
    removalPath.remove();
  });
};

exports.default = removeReferences;